package cn.bsl.bxbg.zhiban.fragment;

import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.adapter.ShiftAdapter;
import cn.bsl.bxbg.zhiban.bean.ShiftBean;
import cn.bsl.bxbg.zhiban.net.client.DutyPlanClient;
import cn.bsl.bxbg.zhiban.utils.Constant;
import cn.bsl.bxbg.zhiban.utils.DateUtils;
import cn.bsl.bxbg.zhiban.view.TakeOverDetailsActivity;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.schedulers.Schedulers;

/**
 * Created by Xinghx on 2018/5/20 0020.
 */

public class AlreadyTakeOverFragment extends BaseFragment implements AdapterView.OnItemClickListener{
    @BindView(R.id.not_finish_lv)
    ListView notFinishLv;
    @BindView(R.id.none)
    TextView none;
    Unbinder unbinder;
    private View rootView;
    private List<ShiftBean> shiftBeen = new ArrayList<>();
    private DutyPlanClient dutyPlanClient = new DutyPlanClient();
    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        rootView = inflater.inflate(R.layout.waitme_fragment, container, false);
        unbinder = ButterKnife.bind(this, rootView);
        initData();
        return rootView;

    }

    private void initData() {
        dutyPlanClient.shiftList(DateUtils.getMonth(), Constant.USER_NAME,"handover")
                .observeOn(AndroidSchedulers.mainThread())
                .subscribeOn(Schedulers.io())
                .subscribe(shiftBeen -> {
                    this.shiftBeen.clear();
                    for (int i = 0; i < shiftBeen.size(); i++) {
                        if (shiftBeen.get(i).getRemark().equals("2")) {
                            this.shiftBeen.add(shiftBeen.get(i));
                        }
                    }

                    notFinishLv.setAdapter(new ShiftAdapter(this.shiftBeen));
                    notFinishLv.setOnItemClickListener(this);
                },Throwable::printStackTrace);
    }


    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Intent intent = new Intent(getActivity(), TakeOverDetailsActivity.class);
        intent.putExtra("id", shiftBeen.get(position).getId());
        intent.putExtra("status", shiftBeen.get(position).getRemark());
        intent.putExtra("dutyTime", shiftBeen.get(position).getDutyDate());
        intent.putExtra("dutyShift", shiftBeen.get(position).getDutyShift());
        intent.putExtra("dutyContent", shiftBeen.get(position).getDutyContent());
        startActivityForResult(intent, 0);
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        initData();
    }
}
