package cn.bsl.bxbg.zhiban.view;

import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.adapter.EListAdapter;
import cn.bsl.bxbg.zhiban.adapter.PopAdapter;
import cn.bsl.bxbg.zhiban.bean.Dept;
import cn.bsl.bxbg.zhiban.bean.GroupPeople;
import cn.bsl.bxbg.zhiban.bean.User;
import cn.bsl.bxbg.zhiban.listener.OnAddUserCountListener;
import cn.bsl.bxbg.zhiban.net.client.AllPeopleClient;
import cn.bsl.bxbg.zhiban.utils.DialogUtil;
import cn.bsl.bxbg.zhiban.utils.LoadDialog;
import me.texy.treeview.TreeNode;
import me.texy.treeview.TreeView;
import me.texy.treeview.TreeViewAdapter;
import me.texy.treeview.bean.TreeChildren;
import me.texy.treeview.binder.MyNodeViewFactory;
import me.texy.treeview.helper.TreeNodeHelper;
import okhttp3.ResponseBody;
import retrofit2.Call;
import retrofit2.Response;


public class AddMeetingPersonActivity2 extends AppCompatActivity implements OnClickListener,OnAddUserCountListener,TreeViewAdapter.OnSingleCheckedListener {
    private static final String TAG = "AddMeetingPersonActivity";
    private ImageView img_back;
    private TextView tv_name, tv_right, tv_count;

    private RadioGroup groups_radiogroup;
    private RadioButton groups_radiobutten01;
    private RadioButton groups_radiobutten02;

    private ArrayList<Dept> groups;
    private ArrayList<Dept> groupGroupList;
    private ArrayList<Dept> groupList;
    //  private ExpandableListView listView;
    private EListAdapter adapter;
    private Button bt_select;
    private PopupWindow popupWindow;
    private ListView pop_list;
    private List<String> list_pop = new ArrayList<String>();
    private String userid;
    private int level;
    private Intent intent;
    private Map<String, List<User>> map;
    private Map<String, User> map_id;
//    private MyReceiver rece;
    private List<Dept> dept;
    private Context mContext;
    private LoadDialog dialog;

    private ViewGroup viewGroup;
    private TreeNode root;
    private TreeView treeView;
    private PopAdapter groupAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_add_meeting_person);
        mContext = this;

        root = TreeNode.root();
        intent = getIntent();
        level = intent.getIntExtra("level", -1);
        dept = (List<Dept>) intent.getSerializableExtra("dept");

//        rece = new MyReceiver();
//        IntentFilter filter = new IntentFilter();
//        filter.addAction("cn.com.bril");
//        registerReceiver(rece, filter);

        initView();
        initEvent();
        initData();
//        groups_radiobutten01.setChecked(true);
    }

    private void initView() {

        viewGroup = (RelativeLayout) findViewById(R.id.container);
        groups_radiogroup = (RadioGroup) findViewById(R.id.radio_group);
        groups_radiobutten01 = (RadioButton) findViewById(R.id.radio_butten01);
        groups_radiobutten02 = (RadioButton) findViewById(R.id.radio_butten02);
        img_back = (ImageView) findViewById(R.id.back);
        tv_name = (TextView) findViewById(R.id.title);
//        tv_right.setBackgroundColor(Color.parseColor("#00000000"));
        tv_name.setText("选择调班人员");
        bt_select = (Button) findViewById(R.id.bt_select);

        groups = new ArrayList<Dept>();

        groupList = new ArrayList<Dept>();
        groupGroupList = new ArrayList<Dept>();
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        Intent intent = new Intent();
        Bundle bundle = new Bundle();
        bundle.putSerializable("result", null);
        intent.putExtras(bundle);
    }

    private void initEvent() {
        img_back.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                onBackPressed();
            }
        });
//        tv_right.setOnClickListener(this);
        tv_name.setOnClickListener(this);

//        groups_radiogroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
//            @Override
//            public void onCheckedChanged(RadioGroup group, int checkedId) {
//
//                if (groups_radiobutten01.getId() == checkedId) {
//                    initData();
//                } else if (groups_radiobutten02.getId() == checkedId) {
//                    try {
//                        initGroupData();
//                    } catch (JSONException e) {
//                        e.printStackTrace();
//                    }
//                }
//            }
//        });
    }

    private void initData() {
        dialog = DialogUtil.getInstance().showLoadDialog(mContext, "请求数据中");
        AllPeopleClient allPeopleClient = new AllPeopleClient();
        allPeopleClient.getAllUser().enqueue(new retrofit2.Callback<ResponseBody>() {
            @Override
            public void onResponse(Call<ResponseBody> call, Response<ResponseBody> response) {
                try {
                    String result = response.body().string();
                    if (null != dialog && dialog.isShowing()) {
                        dialog.dismiss();
                    }
                    String s = result.replace("\"children\":\"\"", "\"children\":[]");
                    List<TreeChildren> list = new Gson().fromJson(s, new TypeToken<List<TreeChildren>>() {
                    }.getType());
                    TreeNodeHelper.buildTree(root, list);
                    if (treeView == null) {
                        treeView = new TreeView(root, mContext, new MyNodeViewFactory(View.GONE));
                        View view = treeView.getView();
                        view.setLayoutParams(new ViewGroup.LayoutParams(
                                ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
                        viewGroup.addView(view);
                    } else {
                        treeView.refreshTreeView();
                    }
                    treeView.expandLevel(0);
                    treeView.setTreeViewSingleListener(AddMeetingPersonActivity2.this);
                } catch (IOException e) {
                    e.printStackTrace();
                }


            }

            @Override
            public void onFailure(Call<ResponseBody> call, Throwable t) {
                t.printStackTrace();
            }
        });



//        dialog = DialogUtil.getInstance().showLoadDialog(mContext, "请求数据中");
//        RequestParams params = new RequestParams(Constant.ALLUSER);//
//        params.addBodyParameter("userId", Constant.USER_ID+"");
//        x.http().post(params, new Callback.CommonCallback<String>() {
//            @Override
//            public void onSuccess(String result) {
//                if (null != dialog && dialog.isShowing()) {
//                    dialog.dismiss();
//                }
//                String s = result.replace("\"children\":\"\"", "\"children\":[]");
//                List<TreeChildren> list = new Gson().fromJson(s, new TypeToken<List<TreeChildren>>() {
//                }.getType());
//                TreeNodeHelper.buildTree(root, list);
//                if (treeView == null) {
//                    treeView = new TreeView(root, mContext, new MyNodeViewFactory(View.GONE));
//                    View view = treeView.getView();
//                    view.setLayoutParams(new ViewGroup.LayoutParams(
//                            ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
//                    viewGroup.addView(view);
//                } else {
//                    treeView.refreshTreeView();
//                }
//                treeView.expandLevel(0);
//                treeView.setTreeViewSingleListener(AddMeetingPersonActivity2.this);
//
//            }
//
//            @Override
//            public void onError(Throwable ex, boolean isOnCallback) {
//                if (null != dialog && dialog.isShowing()) {
//                    dialog.dismiss();
//                }
//                Toast.makeText(mContext, "", Toast.LENGTH_SHORT).show();
//
//            }
//
//            @Override
//            public void onCancelled(CancelledException cex) {
//                if (null != dialog && dialog.isShowing())
//                    dialog.dismiss();
//            }
//
//            @Override
//            public void onFinished() {
//                    if (null != dialog && dialog.isShowing())
//                        dialog.dismiss();
//            }
//        });
    }

//    private void initGroupData() throws JSONException {
//        dialog = DialogUtil.getInstance().showLoadDialog(mContext, R.string.toast_web_wait);
//        JSONObject obj=new JSONObject();
//        obj.put("userid",Constant.USER_ID);
//        RequestParams params=new RequestParams(Constant.GET_DEPT_PERSON);
//        params.addBodyParameter("p", obj.toString());
//        x.http().get(params, new Callback.CommonCallback<String>() {
//            @Override
//            public void onSuccess(String result) {
//                if (null != dialog && dialog.isShowing()) {
//                    dialog.dismiss();
//                }
//                groupGroupList.clear();
//                List<GroupPeople> l = GsonUtil.getInstance().fromJson(result, new TypeToken<List<GroupPeople>>() {
//                }.getType());
//                if (l == null) {
//                    return;
//                }
//
//                buildGroupTree(root, l);
//                if (treeView == null) {
//                    treeView = new TreeView(root, mContext, new MyNodeViewFactory());
//                    View view = treeView.getView();
//                    view.setLayoutParams(new ViewGroup.LayoutParams(
//                            ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
//                    viewGroup.addView(view);
//                } else {
//                    treeView.refreshTreeView();
//                }
//                treeView.expandLevel(0);
//            }
//
//            @Override
//            public void onError(Throwable ex, boolean isOnCallback) {
//                if (null != dialog && dialog.isShowing()) {
//                    dialog.dismiss();
//                }
//                Toast.makeText(mContext, R.string.toast_web_failure, Toast.LENGTH_SHORT).show();
//
//            }
//
//            @Override
//            public void onCancelled(CancelledException cex) {
//                if (null != dialog && dialog.isShowing()) {
//                    dialog.dismiss();
//                }
//            }
//
//            @Override
//            public void onFinished() {
//                if (null != dialog && dialog.isShowing()) {
//                    dialog.dismiss();
//                }
//            }
//        });
//    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.bt_select:
                showPop(v);
                break;
//            case R.id.tv_ok:
//                Intent intent = new Intent();
//                Bundle bundle = new Bundle();
//                bundle.putSerializable("result", root);
//                intent.putExtras(bundle);
//                setResult(RESULT_OK, intent);
//                finish();
//                break;
            case R.id.tv_name:
                 showPop(v);
                break;
            default:
                break;
        }
    }
    public TreeNode buildGroupTree(TreeNode root, List<GroupPeople> list) {

        root.getChildren().clear();
        TreeNode treeNode0 = new TreeNode("保定市检务通", "保定市检务通");
        treeNode0.setLevel(0);
        root.addChild(treeNode0);

        for (int i = 0; i < list.size(); i++) {
            TreeNode treeNode = new TreeNode(new String(list.get(i).getTitleName()), list.get(i).getTitleName());
            treeNode.setLevel(1);
            if (list.get(i).getIdentityUser() != null && list.get(i).getIdentityUser().size() > 0) {
                for (int j = 0; j < list.get(i).getIdentityUser().size(); j++) {
                    TreeNode treeNode1 = new TreeNode(new String(list.get(i).getIdentityUser().get(j).getUsename()), list.get(i).getIdentityUser().get(j).getUserid() + "");
                    treeNode1.setLevel(2);
                    treeNode.addChild(treeNode1);
                }
            }
            root.getChildren().get(0).addChild(treeNode);
        }
        return root;
    }

    public void showPop(View parent) {
        if (popupWindow == null) {
            View view = LayoutInflater.from(this).inflate(R.layout.pop_list, null);
            pop_list = (ListView) view.findViewById(R.id.pop_list);
            groupAdapter = new PopAdapter(this, list_pop);
            pop_list.setAdapter(groupAdapter);
            // 创建一个PopuWidow对象
            WindowManager windowManager = (WindowManager) getSystemService(Context.WINDOW_SERVICE);
            int wid = windowManager.getDefaultDisplay().getWidth() / 4 * 3;
            int heig = windowManager.getDefaultDisplay().getHeight() / 3;
            popupWindow = new PopupWindow(view, wid, heig);
        }

        // 使其聚集
        popupWindow.setFocusable(true);
        // 设置允许在外点击消失
        popupWindow.setOutsideTouchable(true);

        // 这个是为了点击“返回Back”也能使其消失，并且并不会影响你的背景
        popupWindow.setBackgroundDrawable(new BitmapDrawable());
        WindowManager windowManager = (WindowManager) getSystemService(Context.WINDOW_SERVICE);
        // 显示的位置为:屏幕的宽度的一半-PopupWindow的高度的一半
        int xPos = windowManager.getDefaultDisplay().getWidth() / 2 - popupWindow.getWidth() / 2;
        Log.i("coder", "xPos:" + xPos);

        popupWindow.showAsDropDown(parent, -xPos, 0);

        pop_list.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int position, long id) {

                CheckBox cb = (CheckBox) view.findViewById(R.id.checkbox);
                boolean flg = cb.isChecked();
                if (flg) {
                    cb.setChecked(false);
                    for (int i = 0; i < groups.size(); i++) {
                        List<User> list = groups.get(i).getChildren();
                        for (int j = 0; j < list.size(); j++) {
                            if ((position + 1 + "").equals(list.get(j).getRolecode())) {
                                list.get(j).setChecked(false);
                            }
                        }
                    }
                    adapter.notifyDataSetChanged();
                } else {
                    cb.setChecked(true);
                    for (int i = 0; i < groups.size(); i++) {
                        List<User> list = groups.get(i).getChildren();
                        for (int j = 0; j < list.size(); j++) {
                            if ((position + 1 + "").equals(list.get(j).getRolecode())) {
                                list.get(j).setChecked(true);
                            }
                        }
                    }
                    adapter.notifyDataSetChanged();
                }
                if (popupWindow != null) {
                    popupWindow.dismiss();
                }
            }
        });
    }


//    class MyReceiver extends BroadcastReceiver {
//
//        @Override
//        public void onReceive(Context context, Intent intent) {
//            String count = intent.getStringExtra("count");
//        }
//    }

    @Override
    protected void onDestroy() {
        // TODO Auto-generated method stub
        super.onDestroy();
//        unregisterReceiver(rece);
    }
    @Override
    public void OnAddUserCountListener(int num) {
        // TODO Auto-generated method stub

    }

    @Override
    public void singleChecked(TreeNode treeNode) {
        Intent intent = new Intent();
        Bundle bundle = new Bundle();
        bundle.putSerializable("result", treeNode);
        intent.putExtras(bundle);
        setResult(RESULT_OK, intent);
        finish();
    }
}
